OscRecv recv;
8889 => recv.port;
recv.listen();
recv.event( "/hcXNA/stream, f f f f" ) @=> OscEvent oe_stream;
recv.event( "/hcXNA/event, i" ) @=> OscEvent oe_event;

SinOsc m1L => SinOsc c1L => Envelope eL => NRev rev => dac;
SinOsc m2L => SinOsc c2L => eL;
48 => int pL1;
55 => int pL2;
Std.mtof(pL1) => c1L.freq;
Std.mtof(pL2) => c2L.freq;
Std.mtof(pL1) * 4 => m1L.freq;
Std.mtof(pL2) * 4 => m2L.freq;
50 => m1L.gain;
70 => m2L.gain;
0.1 => rev.mix;

SinOsc m1R => SinOsc c1R => Envelope eR => rev;
SinOsc m2R => SinOsc c2R => eR;
60 => int pR1;
67 => int pR2;
Std.mtof(pR1) => c1R.freq;
Std.mtof(pR2) => c2R.freq;
Std.mtof(pR1) * 4 => m1R.freq;
Std.mtof(pR2) * 4 => m2R.freq;
50 => m1R.gain;
70 => m2R.gain;

Step lhx => LPF llpf => TriOsc lhs => Envelope lhe => dac;
Step rhx => LPF rlpf => SinOsc rhs => Envelope rhe => dac;
10 => llpf.freq => rlpf.freq;
0.02 => lhs.gain => rhs.gain;
1.0 => lhe.value => rhe.value;
100::ms => lhe.duration => rhe.duration;

spork ~ processStreamOSC();
spork ~ processEventOSC();

while ( true )
{
    1::second => now;
}

fun void processStreamOSC() {

    float frhx, flhx;
    
    while ( true )
    {
        oe_stream => now;
        while ( oe_stream.nextMsg() != 0 )
        { 
            // get first one
            oe_stream.getFloat() => frhx;
            
            if ( frhx == -1.0 )
            {
                // do nothing, turn off audio
                0.0 => lhe.target => rhe.target;
                oe_stream.getFloat();
                oe_stream.getFloat();
                oe_stream.getFloat();
            }
            else
            {
                1.0 => lhe.target => rhe.target;
                oe_stream.getFloat();
                oe_stream.getFloat() => flhx;
                oe_stream.getFloat();
                
                // and do something
                //frhx + 220 => rhx.next;
                frhx * 2.0 + 110 => rhx.next;
                flhx * 2.0 + 55 => lhx.next;
            }
            
            // <<< frhx, flhx >>>;
            
            17::ms => now;
        }
    }
}

fun void processEventOSC() {
    while ( true )
    {
        oe_event => now;
        while ( oe_event.nextMsg() != 0 )
        { 
            oe_event.getInt() => int which;
            
            if ( which < 0 ) playL(Math.abs(which));
            else if ( which > 0 ) playR(Math.abs(which));
        }
    }
}

fun void playL(int amt)
{
    10::ms => eL.duration;
    (amt*0.1) + 0.2 => eL.target;
    10::ms => now;
    0.0 => eL.target;
    800::ms => eL.duration;
    1000::ms => now;
}

fun void playR(int amt)
{
    10::ms => eR.duration;
    (amt*0.1) + 0.2 => eR.target;
    10::ms => now;
    0.0 => eR.target;
    800::ms => eR.duration;
    1000::ms => now;
}