﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace hcXNA
{
    // app setting class
    public class hcSetting
    {
        // kinect and renderer
        public bool DEBUG_MODE;
        public bool KINECT_CONNECTED;
        public bool KINECT_VIDEO;
        public bool LOCAL_MODE;
        public int kinectWidth, kinectHeight;
        public int Width, Height;
        public float HCenter, VCenter;
        public int skeletonPreviewX, skeletonPreviewY;
        public int skeletonPreviewW, skeletonPreviewH;
        public float transSpeed;

        // osc stuff
        public readonly string clientID = "master";
        public readonly string OscServerURL = "192.168.183.134";
        public readonly string ServerURL = "192.168.183.134";
        public readonly int HttpPort = 3780;
        public readonly int OscPort = 8889;
        public readonly string DefaultOscPath = "";

        // CTOR
        public hcSetting()
        {
            DEBUG_MODE = true;
            KINECT_CONNECTED = false; // it will automatically populate the device
            KINECT_VIDEO = false; // use preview video
            LOCAL_MODE = false; // if connected to server, set this to false
            kinectWidth = 640;
            kinectHeight = 480;
            Width = 800;
            Height = 600;
            HCenter = Width / 2.0f;
            VCenter = Height / 2.0f;
            skeletonPreviewW = kinectWidth / 4;
            skeletonPreviewH = kinectHeight / 4;
            skeletonPreviewX = 10;
            skeletonPreviewY = (int)VCenter - ( skeletonPreviewH );
            transSpeed = 0.1f;
        }
    }

    // hcNetMsgTester
    public class hcNetMsgTester
    {
        // members
        hcNetSender testSender;
        int _currentIdx;
        string[] _messages =
        {
            "/idle",
            "/identifying",
            "/identified/1",
            "/identified/2",
            "/photodesk",
            "/photodesk/swipeleft",
            "/photodesk/swiperight",
            "/photodesk/hover/0",
            "/photodesk/hover/1",
            "/photodesk/hover/2",
            "/photodesk/hover/3",
            "/browsing/0",
            "/browsing/1",
            "/browsing/2",
            "/browsing/3",
            "/browsing/scrollright/1",
            "/browsing/scrollright/3",
            "/browsing/scrollright/7",
            "/browsing/scrollleft/1",
            "/browsing/scrollleft/3",
            "/browsing/scrollleft/7",
            "/rating",
            "/rating/1",
            "/rating/2",
            "/rating/3",
            "/rating/4",
            "/rating/5",
            "/rating/finish",
            "/usericon/gray",
            "/usericon/green",
            "/usericon/none"
        };

        // ctor
        public hcNetMsgTester(hcSetting setting)
        {
            testSender = new hcNetSender(setting);
            _currentIdx = 0;
        }

        // select next message
        public void nextMsg()
        {
            // increase and wrapping around
            if (++_currentIdx == _messages.Length) _currentIdx = 0;
        }

        // select prev message        
        public void prevMsg()
        {
            // increase and wrapping around
            if (--_currentIdx < 0) _currentIdx = _messages.Length-1;
        }

        // get message
        public string getMsg()
        {
            return _messages[_currentIdx];
        }

        // sendNetMsg(): 1 string
        public void sendNetMsg()
        {
            // send http, osc message
            testSender.sendHttpRequest(_messages[_currentIdx]);
            testSender.sendOscMsg(_messages[_currentIdx], 5);
        }
    }
}
